package fishrungames.bashgid.core;

import java.util.HashMap;

import fishrungames.bashgid.R;

import android.util.Log;
import android.widget.ImageView;

public class ImageManager {

	static ImageManager instance = null;
	
	public static ImageManager getInstance()
	{
		if (instance == null)
		{
			instance = new ImageManager();
		}
		
		return instance;
	}
	
	
	HashMap<String, Integer> PredefinedImageId = new HashMap<String, Integer>();
	
	public ImageManager()
	{
		PredefinedImageId.put("R.drawable.news_image1", R.drawable.news_image1);
		PredefinedImageId.put("R.drawable.news_image2", R.drawable.news_image2);
		PredefinedImageId.put("R.drawable.news_image3", R.drawable.news_image3);
	}
	
	
	
	
	public void ApplyImageToImageView(ImageView imageView, String imageId)
	{
		if (imageId.startsWith("R.drawable."))
		{
			Integer resourceId = PredefinedImageId.get(imageId);
			
			if (resourceId == null)
			{
				Log.e("Error: ", "Image not added to PredefinedImageId: " + imageId);
				
				resourceId = R.drawable.transparent;
			}
			
			imageView.setImageResource(resourceId);
		}
	}
	
	
	
}
