package fishrungames.bashgid.core;

import java.util.ArrayList;

public class NewsManager {

	private static NewsManager instance = null;
	
	
	public static NewsManager GetInstance()
	{
		if (instance == null)
		{
			instance = new NewsManager();
		}
		
		return instance;
	}
	
	
	public static class NewsRecord
	{
		public String title;
		public String description;
		public String imageId;
		
		NewsRecord(String title, String description, String imageId)
		{
			this.title = title;
			this.description = description;
			this.imageId = imageId;
		}
		
		NewsRecord(RssReader.Rss2Item rss2Item)
		{
			this.title = rss2Item.title;
			this.description = rss2Item.description;
			this.imageId = "R.drawable.news_image1";
		}
	}
	
	ArrayList<NewsRecord> newsRecord = new ArrayList<NewsRecord>();
	
	public void DownloadNews(NewsUpdatedCallbackInterface callback)
	{
		Thread thread = new Thread(new DownloadNewsRunnable(callback));
		
		thread.start();
	}
	
	class DownloadNewsRunnable implements Runnable
	{
		
		NewsUpdatedCallbackInterface callback;
		
		public DownloadNewsRunnable(NewsUpdatedCallbackInterface callback)
		{
			this.callback = callback;
		}
		
		@Override
		public void run()
		{
			String xmlCode = DownloadManager.getXmlFromUrl("http://www.bashinform.ru/rss/all.xml");
			
			RssReader rssReader = new RssReader();
			
			rssReader.ReadRss(xmlCode);
			
			ArrayList<NewsRecord> localNewsRecord = new ArrayList<NewsRecord>();
			
			for (RssReader.Rss2Item rss2Item : rssReader.rss2ItemArr)
			{
				localNewsRecord.add(new NewsRecord(rss2Item));
			}
			
			//Xperimental -- need mutex right here
			newsRecord = localNewsRecord;
			
			callback.OnNewsUpdated();
		}
	}
	
	public static interface NewsUpdatedCallbackInterface
	{
		public void OnNewsUpdated();
	}
	
	
	public NewsManager()
	{
		newsRecord.add(new NewsRecord("Власти Башкирии создадут выезд из Уфы на трассу М-5 «Урал»", "Власти Башкирии создадут выезд из Уфы на трассу М-5 «Урал»", "R.drawable.news_image1"));
		newsRecord.add(new NewsRecord("Башкирия заняла первое место индекса «деловой активности»", "Башкирия заняла первое место индекса «деловой активности»", "R.drawable.news_image2"));
		newsRecord.add(new NewsRecord("«Салават Юлаев» обыграл «Ладу» и прервал серию из 5 поражений в КХЛ", "«Салават Юлаев» обыграл «Ладу» и прервал серию из 5 поражений в КХЛ", "R.drawable.news_image3"));
	}
	
	
	public ArrayList<NewsRecord> getNews()
	{
		return newsRecord;
	}
	
	
	
	
}
